#include <iostream>
#include <cstring>   // for memcpy

using namespace std;

// rotate the board 90 degrees clockwise
void rotate(int board[4][4]) {
    int after[4][4];

    for (int r = 0; r < 4; ++r) {
        for (int c = 0; c < 4; ++c) {
            after[r][c] = board[c][3-r];
        }
    }

    // could use a double for loop again to copy, but might as well learn something!
    memcpy(board, after, sizeof(after));
}

// slide the tiles left in a single row
void slideLeft(int row[4]) {
    // idea: get the list of nonzero entries
    //       try pairing them up, left to right
    //       then rewrite the new entries to the row

    // get the nonzero numbers
    int nums[4], n = 0;
    for (int i = 0; i < 4; ++i) {
        if (row[i] != 0) {
            nums[n] = row[i];
            ++n;
        }
    }
    // now n is the number of nonzero numbers

    int at = 0;
    // try pairing them up left to right, and writing them to row
    for (int i = 0; i < n; ++i) {
        if (i+1 < n && nums[i] == nums[i+1]) {
            row[at] = 2*nums[i];
            ++i; // in this case, i gets incremented twice
                 // (one in the loop statment above) to skip past the pair
        }
        else {
            row[at] = nums[i]; // just copy the number, not paired
        }
        ++at; // we recorded a number to row
    }

    // now fill the rest of the row with 0s
    for (; at < 4; ++at) { // nothing new to initialize
        row[at] = 0;
    }
}

int main() {
    int board[4][4], k;
    // read in the board
    for (int i = 0; i < 4; ++i) {
        for (int j = 0; j < 4; ++j) {
            cin >> board[i][j];
        }
    }
    cin >> k;

    // rotate the board so whatever k is, we just have to slide left
    for (int i = 0; i < k; ++i) rotate(board);

    // slide each row left
    for (int r = 0; r < 4; ++r) slideLeft(board[r]);

    // now rotate the board back to the original orientation
    for (int i = 0; i < 4-k; ++i) rotate(board);

    // all done, print it out!
    for (int r = 0; r < 4; ++r) {
        for (int c = 0; c < 4; ++c) {
            // funny ? : notation is a ternary operator
            cout << board[r][c] << (c==3?'\n':' ');
        }
    }

    return 0;
}
